/*----- PROTECTED REGION ID(Standa8smc4usbClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Standa8smc4usbClass.cpp
//
// description : C++ source for the Standa8smc4usbClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Standa8smc4usb once per process.
//
// project :     StandaTango
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Standa8smc4usbClass.h>

/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass.cpp

//-------------------------------------------------------------------
/**
 *	Create Standa8smc4usbClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Standa8smc4usb_class(const char *name) {
		return Standa8smc4usb_ns::Standa8smc4usbClass::init(name);
	}
}

namespace Standa8smc4usb_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Standa8smc4usbClass *Standa8smc4usbClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Standa8smc4usbClass::Standa8smc4usbClass(string &s)
 * description : 	constructor for the Standa8smc4usbClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Standa8smc4usbClass::Standa8smc4usbClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering Standa8smc4usbClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Standa8smc4usbClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::constructor

	cout2 << "Leaving Standa8smc4usbClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		Standa8smc4usbClass::~Standa8smc4usbClass()
 * description : 	destructor for the Standa8smc4usbClass
 */
//--------------------------------------------------------
Standa8smc4usbClass::~Standa8smc4usbClass()
{
	/*----- PROTECTED REGION ID(Standa8smc4usbClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Standa8smc4usbClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Standa8smc4usbClass *Standa8smc4usbClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Standa8smc4usbClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Standa8smc4usbClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Standa8smc4usbClass *Standa8smc4usbClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		LeftClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *LeftClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "LeftClass::execute(): arrived" << endl;
	((static_cast<Standa8smc4usb *>(device))->left());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RightClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RightClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "RightClass::execute(): arrived" << endl;
	((static_cast<Standa8smc4usb *>(device))->right());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StopClass::execute(): arrived" << endl;
	((static_cast<Standa8smc4usb *>(device))->stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SstopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SstopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SstopClass::execute(): arrived" << endl;
	((static_cast<Standa8smc4usb *>(device))->sstop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MoveClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MoveClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "MoveClass::execute(): arrived" << endl;
	Tango::DevFloat argin;
	extract(in_any, argin);
	((static_cast<Standa8smc4usb *>(device))->move(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MoverClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MoverClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "MoverClass::execute(): arrived" << endl;
	Tango::DevFloat argin;
	extract(in_any, argin);
	((static_cast<Standa8smc4usb *>(device))->mover(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		HomeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *HomeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "HomeClass::execute(): arrived" << endl;
	((static_cast<Standa8smc4usb *>(device))->home());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : Standa8smc4usbClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Standa8smc4usbClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Standa8smc4usbClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Standa8smc4usbClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Standa8smc4usbClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Standa8smc4usbClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Standa8smc4usbClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Standa8smc4usbClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "SerialNumber";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CalibrationRatio";
	prop_desc = "";
	prop_def  = "1.0";
	vect_data.clear();
	vect_data.push_back("1.0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CalibrationUnits";
	prop_desc = "";
	prop_def  = "mm";
	vect_data.clear();
	vect_data.push_back("mm");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : Standa8smc4usbClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Standa8smc4usbClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("StandaTango");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("Standa8smc4usb");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : Standa8smc4usbClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Standa8smc4usbClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Standa8smc4usbClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Standa8smc4usb(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Standa8smc4usb *dev = static_cast<Standa8smc4usb *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Standa8smc4usbClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Standa8smc4usbClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Standa8smc4usbClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Standa8smc4usbClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::attribute_factory_before
	//	Attribute : speed
	speedAttrib	*speed = new speedAttrib();
	Tango::UserDefaultAttrProp	speed_prop;
	//	description	not set for speed
	//	label	not set for speed
	//	unit	not set for speed
	//	standard_unit	not set for speed
	//	display_unit	not set for speed
	//	format	not set for speed
	//	max_value	not set for speed
	//	min_value	not set for speed
	//	max_alarm	not set for speed
	//	min_alarm	not set for speed
	//	max_warning	not set for speed
	//	min_warning	not set for speed
	//	delta_t	not set for speed
	//	delta_val	not set for speed
	
	speed->set_default_properties(speed_prop);
	//	Not Polled
	speed->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(speed);

	//	Attribute : accel
	accelAttrib	*accel = new accelAttrib();
	Tango::UserDefaultAttrProp	accel_prop;
	//	description	not set for accel
	//	label	not set for accel
	//	unit	not set for accel
	//	standard_unit	not set for accel
	//	display_unit	not set for accel
	//	format	not set for accel
	//	max_value	not set for accel
	//	min_value	not set for accel
	//	max_alarm	not set for accel
	//	min_alarm	not set for accel
	//	max_warning	not set for accel
	//	min_warning	not set for accel
	//	delta_t	not set for accel
	//	delta_val	not set for accel
	
	accel->set_default_properties(accel_prop);
	//	Not Polled
	accel->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(accel);

	//	Attribute : decel
	decelAttrib	*decel = new decelAttrib();
	Tango::UserDefaultAttrProp	decel_prop;
	//	description	not set for decel
	//	label	not set for decel
	//	unit	not set for decel
	//	standard_unit	not set for decel
	//	display_unit	not set for decel
	//	format	not set for decel
	//	max_value	not set for decel
	//	min_value	not set for decel
	//	max_alarm	not set for decel
	//	min_alarm	not set for decel
	//	max_warning	not set for decel
	//	min_warning	not set for decel
	//	delta_t	not set for decel
	//	delta_val	not set for decel
	
	decel->set_default_properties(decel_prop);
	//	Not Polled
	decel->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(decel);

	//	Attribute : antiplaySpeed
	antiplaySpeedAttrib	*antiplayspeed = new antiplaySpeedAttrib();
	Tango::UserDefaultAttrProp	antiplayspeed_prop;
	//	description	not set for antiplaySpeed
	//	label	not set for antiplaySpeed
	//	unit	not set for antiplaySpeed
	//	standard_unit	not set for antiplaySpeed
	//	display_unit	not set for antiplaySpeed
	//	format	not set for antiplaySpeed
	//	max_value	not set for antiplaySpeed
	//	min_value	not set for antiplaySpeed
	//	max_alarm	not set for antiplaySpeed
	//	min_alarm	not set for antiplaySpeed
	//	max_warning	not set for antiplaySpeed
	//	min_warning	not set for antiplaySpeed
	//	delta_t	not set for antiplaySpeed
	//	delta_val	not set for antiplaySpeed
	
	antiplayspeed->set_default_properties(antiplayspeed_prop);
	//	Not Polled
	antiplayspeed->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(antiplayspeed);

	//	Attribute : moveSts
	moveStsAttrib	*movests = new moveStsAttrib();
	Tango::UserDefaultAttrProp	movests_prop;
	//	description	not set for moveSts
	//	label	not set for moveSts
	//	unit	not set for moveSts
	//	standard_unit	not set for moveSts
	//	display_unit	not set for moveSts
	//	format	not set for moveSts
	//	max_value	not set for moveSts
	//	min_value	not set for moveSts
	//	max_alarm	not set for moveSts
	//	min_alarm	not set for moveSts
	//	max_warning	not set for moveSts
	//	min_warning	not set for moveSts
	//	delta_t	not set for moveSts
	//	delta_val	not set for moveSts
	
	movests->set_default_properties(movests_prop);
	//	Not Polled
	movests->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(movests);

	//	Attribute : mvCmdSts
	mvCmdStsAttrib	*mvcmdsts = new mvCmdStsAttrib();
	Tango::UserDefaultAttrProp	mvcmdsts_prop;
	//	description	not set for mvCmdSts
	//	label	not set for mvCmdSts
	//	unit	not set for mvCmdSts
	//	standard_unit	not set for mvCmdSts
	//	display_unit	not set for mvCmdSts
	//	format	not set for mvCmdSts
	//	max_value	not set for mvCmdSts
	//	min_value	not set for mvCmdSts
	//	max_alarm	not set for mvCmdSts
	//	min_alarm	not set for mvCmdSts
	//	max_warning	not set for mvCmdSts
	//	min_warning	not set for mvCmdSts
	//	delta_t	not set for mvCmdSts
	//	delta_val	not set for mvCmdSts
	
	mvcmdsts->set_default_properties(mvcmdsts_prop);
	//	Not Polled
	mvcmdsts->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(mvcmdsts);

	//	Attribute : pwrSts
	pwrStsAttrib	*pwrsts = new pwrStsAttrib();
	Tango::UserDefaultAttrProp	pwrsts_prop;
	//	description	not set for pwrSts
	//	label	not set for pwrSts
	//	unit	not set for pwrSts
	//	standard_unit	not set for pwrSts
	//	display_unit	not set for pwrSts
	//	format	not set for pwrSts
	//	max_value	not set for pwrSts
	//	min_value	not set for pwrSts
	//	max_alarm	not set for pwrSts
	//	min_alarm	not set for pwrSts
	//	max_warning	not set for pwrSts
	//	min_warning	not set for pwrSts
	//	delta_t	not set for pwrSts
	//	delta_val	not set for pwrSts
	
	pwrsts->set_default_properties(pwrsts_prop);
	//	Not Polled
	pwrsts->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pwrsts);

	//	Attribute : encSts
	encStsAttrib	*encsts = new encStsAttrib();
	Tango::UserDefaultAttrProp	encsts_prop;
	//	description	not set for encSts
	//	label	not set for encSts
	//	unit	not set for encSts
	//	standard_unit	not set for encSts
	//	display_unit	not set for encSts
	//	format	not set for encSts
	//	max_value	not set for encSts
	//	min_value	not set for encSts
	//	max_alarm	not set for encSts
	//	min_alarm	not set for encSts
	//	max_warning	not set for encSts
	//	min_warning	not set for encSts
	//	delta_t	not set for encSts
	//	delta_val	not set for encSts
	
	encsts->set_default_properties(encsts_prop);
	//	Not Polled
	encsts->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(encsts);

	//	Attribute : windSts
	windStsAttrib	*windsts = new windStsAttrib();
	Tango::UserDefaultAttrProp	windsts_prop;
	//	description	not set for windSts
	//	label	not set for windSts
	//	unit	not set for windSts
	//	standard_unit	not set for windSts
	//	display_unit	not set for windSts
	//	format	not set for windSts
	//	max_value	not set for windSts
	//	min_value	not set for windSts
	//	max_alarm	not set for windSts
	//	min_alarm	not set for windSts
	//	max_warning	not set for windSts
	//	min_warning	not set for windSts
	//	delta_t	not set for windSts
	//	delta_val	not set for windSts
	
	windsts->set_default_properties(windsts_prop);
	//	Not Polled
	windsts->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(windsts);

	//	Attribute : curPosition
	curPositionAttrib	*curposition = new curPositionAttrib();
	Tango::UserDefaultAttrProp	curposition_prop;
	//	description	not set for curPosition
	//	label	not set for curPosition
	//	unit	not set for curPosition
	//	standard_unit	not set for curPosition
	//	display_unit	not set for curPosition
	//	format	not set for curPosition
	//	max_value	not set for curPosition
	//	min_value	not set for curPosition
	//	max_alarm	not set for curPosition
	//	min_alarm	not set for curPosition
	//	max_warning	not set for curPosition
	//	min_warning	not set for curPosition
	//	delta_t	not set for curPosition
	//	delta_val	not set for curPosition
	
	curposition->set_default_properties(curposition_prop);
	//	Not Polled
	curposition->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(curposition);

	//	Attribute : encPosition
	encPositionAttrib	*encposition = new encPositionAttrib();
	Tango::UserDefaultAttrProp	encposition_prop;
	//	description	not set for encPosition
	//	label	not set for encPosition
	//	unit	not set for encPosition
	//	standard_unit	not set for encPosition
	//	display_unit	not set for encPosition
	//	format	not set for encPosition
	//	max_value	not set for encPosition
	//	min_value	not set for encPosition
	//	max_alarm	not set for encPosition
	//	min_alarm	not set for encPosition
	//	max_warning	not set for encPosition
	//	min_warning	not set for encPosition
	//	delta_t	not set for encPosition
	//	delta_val	not set for encPosition
	
	encposition->set_default_properties(encposition_prop);
	//	Not Polled
	encposition->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(encposition);

	//	Attribute : curSpeed
	curSpeedAttrib	*curspeed = new curSpeedAttrib();
	Tango::UserDefaultAttrProp	curspeed_prop;
	//	description	not set for curSpeed
	//	label	not set for curSpeed
	//	unit	not set for curSpeed
	//	standard_unit	not set for curSpeed
	//	display_unit	not set for curSpeed
	//	format	not set for curSpeed
	//	max_value	not set for curSpeed
	//	min_value	not set for curSpeed
	//	max_alarm	not set for curSpeed
	//	min_alarm	not set for curSpeed
	//	max_warning	not set for curSpeed
	//	min_warning	not set for curSpeed
	//	delta_t	not set for curSpeed
	//	delta_val	not set for curSpeed
	
	curspeed->set_default_properties(curspeed_prop);
	//	Not Polled
	curspeed->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(curspeed);

	//	Attribute : ipwr
	ipwrAttrib	*ipwr = new ipwrAttrib();
	Tango::UserDefaultAttrProp	ipwr_prop;
	//	description	not set for ipwr
	//	label	not set for ipwr
	//	unit	not set for ipwr
	//	standard_unit	not set for ipwr
	//	display_unit	not set for ipwr
	//	format	not set for ipwr
	//	max_value	not set for ipwr
	//	min_value	not set for ipwr
	//	max_alarm	not set for ipwr
	//	min_alarm	not set for ipwr
	//	max_warning	not set for ipwr
	//	min_warning	not set for ipwr
	//	delta_t	not set for ipwr
	//	delta_val	not set for ipwr
	
	ipwr->set_default_properties(ipwr_prop);
	//	Not Polled
	ipwr->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(ipwr);

	//	Attribute : upwr
	upwrAttrib	*upwr = new upwrAttrib();
	Tango::UserDefaultAttrProp	upwr_prop;
	//	description	not set for upwr
	//	label	not set for upwr
	//	unit	not set for upwr
	//	standard_unit	not set for upwr
	//	display_unit	not set for upwr
	//	format	not set for upwr
	//	max_value	not set for upwr
	//	min_value	not set for upwr
	//	max_alarm	not set for upwr
	//	min_alarm	not set for upwr
	//	max_warning	not set for upwr
	//	min_warning	not set for upwr
	//	delta_t	not set for upwr
	//	delta_val	not set for upwr
	
	upwr->set_default_properties(upwr_prop);
	//	Not Polled
	upwr->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(upwr);

	//	Attribute : iusb
	iusbAttrib	*iusb = new iusbAttrib();
	Tango::UserDefaultAttrProp	iusb_prop;
	//	description	not set for iusb
	//	label	not set for iusb
	//	unit	not set for iusb
	//	standard_unit	not set for iusb
	//	display_unit	not set for iusb
	//	format	not set for iusb
	//	max_value	not set for iusb
	//	min_value	not set for iusb
	//	max_alarm	not set for iusb
	//	min_alarm	not set for iusb
	//	max_warning	not set for iusb
	//	min_warning	not set for iusb
	//	delta_t	not set for iusb
	//	delta_val	not set for iusb
	
	iusb->set_default_properties(iusb_prop);
	//	Not Polled
	iusb->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(iusb);

	//	Attribute : uusb
	uusbAttrib	*uusb = new uusbAttrib();
	Tango::UserDefaultAttrProp	uusb_prop;
	//	description	not set for uusb
	//	label	not set for uusb
	//	unit	not set for uusb
	//	standard_unit	not set for uusb
	//	display_unit	not set for uusb
	//	format	not set for uusb
	//	max_value	not set for uusb
	//	min_value	not set for uusb
	//	max_alarm	not set for uusb
	//	min_alarm	not set for uusb
	//	max_warning	not set for uusb
	//	min_warning	not set for uusb
	//	delta_t	not set for uusb
	//	delta_val	not set for uusb
	
	uusb->set_default_properties(uusb_prop);
	//	Not Polled
	uusb->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(uusb);

	//	Attribute : curT
	curTAttrib	*curt = new curTAttrib();
	Tango::UserDefaultAttrProp	curt_prop;
	//	description	not set for curT
	//	label	not set for curT
	//	unit	not set for curT
	//	standard_unit	not set for curT
	//	display_unit	not set for curT
	//	format	not set for curT
	//	max_value	not set for curT
	//	min_value	not set for curT
	//	max_alarm	not set for curT
	//	min_alarm	not set for curT
	//	max_warning	not set for curT
	//	min_warning	not set for curT
	//	delta_t	not set for curT
	//	delta_val	not set for curT
	
	curt->set_default_properties(curt_prop);
	//	Not Polled
	curt->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(curt);

	//	Attribute : flags
	flagsAttrib	*flags = new flagsAttrib();
	Tango::UserDefaultAttrProp	flags_prop;
	//	description	not set for flags
	//	label	not set for flags
	//	unit	not set for flags
	//	standard_unit	not set for flags
	//	display_unit	not set for flags
	//	format	not set for flags
	//	max_value	not set for flags
	//	min_value	not set for flags
	//	max_alarm	not set for flags
	//	min_alarm	not set for flags
	//	max_warning	not set for flags
	//	min_warning	not set for flags
	//	delta_t	not set for flags
	//	delta_val	not set for flags
	
	flags->set_default_properties(flags_prop);
	//	Not Polled
	flags->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(flags);

	//	Attribute : gpioFlags
	gpioFlagsAttrib	*gpioflags = new gpioFlagsAttrib();
	Tango::UserDefaultAttrProp	gpioflags_prop;
	//	description	not set for gpioFlags
	//	label	not set for gpioFlags
	//	unit	not set for gpioFlags
	//	standard_unit	not set for gpioFlags
	//	display_unit	not set for gpioFlags
	//	format	not set for gpioFlags
	//	max_value	not set for gpioFlags
	//	min_value	not set for gpioFlags
	//	max_alarm	not set for gpioFlags
	//	min_alarm	not set for gpioFlags
	//	max_warning	not set for gpioFlags
	//	min_warning	not set for gpioFlags
	//	delta_t	not set for gpioFlags
	//	delta_val	not set for gpioFlags
	
	gpioflags->set_default_properties(gpioflags_prop);
	//	Not Polled
	gpioflags->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(gpioflags);

	//	Attribute : cmdBufFreeSpace
	cmdBufFreeSpaceAttrib	*cmdbuffreespace = new cmdBufFreeSpaceAttrib();
	Tango::UserDefaultAttrProp	cmdbuffreespace_prop;
	//	description	not set for cmdBufFreeSpace
	//	label	not set for cmdBufFreeSpace
	//	unit	not set for cmdBufFreeSpace
	//	standard_unit	not set for cmdBufFreeSpace
	//	display_unit	not set for cmdBufFreeSpace
	//	format	not set for cmdBufFreeSpace
	//	max_value	not set for cmdBufFreeSpace
	//	min_value	not set for cmdBufFreeSpace
	//	max_alarm	not set for cmdBufFreeSpace
	//	min_alarm	not set for cmdBufFreeSpace
	//	max_warning	not set for cmdBufFreeSpace
	//	min_warning	not set for cmdBufFreeSpace
	//	delta_t	not set for cmdBufFreeSpace
	//	delta_val	not set for cmdBufFreeSpace
	
	cmdbuffreespace->set_default_properties(cmdbuffreespace_prop);
	//	Not Polled
	cmdbuffreespace->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cmdbuffreespace);

	//	Attribute : windingVoltageA
	windingVoltageAAttrib	*windingvoltagea = new windingVoltageAAttrib();
	Tango::UserDefaultAttrProp	windingvoltagea_prop;
	//	description	not set for windingVoltageA
	//	label	not set for windingVoltageA
	//	unit	not set for windingVoltageA
	//	standard_unit	not set for windingVoltageA
	//	display_unit	not set for windingVoltageA
	//	format	not set for windingVoltageA
	//	max_value	not set for windingVoltageA
	//	min_value	not set for windingVoltageA
	//	max_alarm	not set for windingVoltageA
	//	min_alarm	not set for windingVoltageA
	//	max_warning	not set for windingVoltageA
	//	min_warning	not set for windingVoltageA
	//	delta_t	not set for windingVoltageA
	//	delta_val	not set for windingVoltageA
	
	windingvoltagea->set_default_properties(windingvoltagea_prop);
	//	Not Polled
	windingvoltagea->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(windingvoltagea);

	//	Attribute : windingVoltageB
	windingVoltageBAttrib	*windingvoltageb = new windingVoltageBAttrib();
	Tango::UserDefaultAttrProp	windingvoltageb_prop;
	//	description	not set for windingVoltageB
	//	label	not set for windingVoltageB
	//	unit	not set for windingVoltageB
	//	standard_unit	not set for windingVoltageB
	//	display_unit	not set for windingVoltageB
	//	format	not set for windingVoltageB
	//	max_value	not set for windingVoltageB
	//	min_value	not set for windingVoltageB
	//	max_alarm	not set for windingVoltageB
	//	min_alarm	not set for windingVoltageB
	//	max_warning	not set for windingVoltageB
	//	min_warning	not set for windingVoltageB
	//	delta_t	not set for windingVoltageB
	//	delta_val	not set for windingVoltageB
	
	windingvoltageb->set_default_properties(windingvoltageb_prop);
	//	Not Polled
	windingvoltageb->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(windingvoltageb);

	//	Attribute : windingVoltageC
	windingVoltageCAttrib	*windingvoltagec = new windingVoltageCAttrib();
	Tango::UserDefaultAttrProp	windingvoltagec_prop;
	//	description	not set for windingVoltageC
	//	label	not set for windingVoltageC
	//	unit	not set for windingVoltageC
	//	standard_unit	not set for windingVoltageC
	//	display_unit	not set for windingVoltageC
	//	format	not set for windingVoltageC
	//	max_value	not set for windingVoltageC
	//	min_value	not set for windingVoltageC
	//	max_alarm	not set for windingVoltageC
	//	min_alarm	not set for windingVoltageC
	//	max_warning	not set for windingVoltageC
	//	min_warning	not set for windingVoltageC
	//	delta_t	not set for windingVoltageC
	//	delta_val	not set for windingVoltageC
	
	windingvoltagec->set_default_properties(windingvoltagec_prop);
	//	Not Polled
	windingvoltagec->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(windingvoltagec);

	//	Attribute : windingCurrentA
	windingCurrentAAttrib	*windingcurrenta = new windingCurrentAAttrib();
	Tango::UserDefaultAttrProp	windingcurrenta_prop;
	//	description	not set for windingCurrentA
	//	label	not set for windingCurrentA
	//	unit	not set for windingCurrentA
	//	standard_unit	not set for windingCurrentA
	//	display_unit	not set for windingCurrentA
	//	format	not set for windingCurrentA
	//	max_value	not set for windingCurrentA
	//	min_value	not set for windingCurrentA
	//	max_alarm	not set for windingCurrentA
	//	min_alarm	not set for windingCurrentA
	//	max_warning	not set for windingCurrentA
	//	min_warning	not set for windingCurrentA
	//	delta_t	not set for windingCurrentA
	//	delta_val	not set for windingCurrentA
	
	windingcurrenta->set_default_properties(windingcurrenta_prop);
	//	Not Polled
	windingcurrenta->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(windingcurrenta);

	//	Attribute : windingCurrentB
	windingCurrentBAttrib	*windingcurrentb = new windingCurrentBAttrib();
	Tango::UserDefaultAttrProp	windingcurrentb_prop;
	//	description	not set for windingCurrentB
	//	label	not set for windingCurrentB
	//	unit	not set for windingCurrentB
	//	standard_unit	not set for windingCurrentB
	//	display_unit	not set for windingCurrentB
	//	format	not set for windingCurrentB
	//	max_value	not set for windingCurrentB
	//	min_value	not set for windingCurrentB
	//	max_alarm	not set for windingCurrentB
	//	min_alarm	not set for windingCurrentB
	//	max_warning	not set for windingCurrentB
	//	min_warning	not set for windingCurrentB
	//	delta_t	not set for windingCurrentB
	//	delta_val	not set for windingCurrentB
	
	windingcurrentb->set_default_properties(windingcurrentb_prop);
	//	Not Polled
	windingcurrentb->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(windingcurrentb);

	//	Attribute : windingCurrentC
	windingCurrentCAttrib	*windingcurrentc = new windingCurrentCAttrib();
	Tango::UserDefaultAttrProp	windingcurrentc_prop;
	//	description	not set for windingCurrentC
	//	label	not set for windingCurrentC
	//	unit	not set for windingCurrentC
	//	standard_unit	not set for windingCurrentC
	//	display_unit	not set for windingCurrentC
	//	format	not set for windingCurrentC
	//	max_value	not set for windingCurrentC
	//	min_value	not set for windingCurrentC
	//	max_alarm	not set for windingCurrentC
	//	min_alarm	not set for windingCurrentC
	//	max_warning	not set for windingCurrentC
	//	min_warning	not set for windingCurrentC
	//	delta_t	not set for windingCurrentC
	//	delta_val	not set for windingCurrentC
	
	windingcurrentc->set_default_properties(windingcurrentc_prop);
	//	Not Polled
	windingcurrentc->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(windingcurrentc);

	//	Attribute : pot
	potAttrib	*pot = new potAttrib();
	Tango::UserDefaultAttrProp	pot_prop;
	//	description	not set for pot
	//	label	not set for pot
	//	unit	not set for pot
	//	standard_unit	not set for pot
	//	display_unit	not set for pot
	//	format	not set for pot
	//	max_value	not set for pot
	//	min_value	not set for pot
	//	max_alarm	not set for pot
	//	min_alarm	not set for pot
	//	max_warning	not set for pot
	//	min_warning	not set for pot
	//	delta_t	not set for pot
	//	delta_val	not set for pot
	
	pot->set_default_properties(pot_prop);
	//	Not Polled
	pot->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pot);

	//	Attribute : joy
	joyAttrib	*joy = new joyAttrib();
	Tango::UserDefaultAttrProp	joy_prop;
	//	description	not set for joy
	//	label	not set for joy
	//	unit	not set for joy
	//	standard_unit	not set for joy
	//	display_unit	not set for joy
	//	format	not set for joy
	//	max_value	not set for joy
	//	min_value	not set for joy
	//	max_alarm	not set for joy
	//	min_alarm	not set for joy
	//	max_warning	not set for joy
	//	min_warning	not set for joy
	//	delta_t	not set for joy
	//	delta_val	not set for joy
	
	joy->set_default_properties(joy_prop);
	//	Not Polled
	joy->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(joy);

	//	Attribute : dutyCycle
	dutyCycleAttrib	*dutycycle = new dutyCycleAttrib();
	Tango::UserDefaultAttrProp	dutycycle_prop;
	//	description	not set for dutyCycle
	//	label	not set for dutyCycle
	//	unit	not set for dutyCycle
	//	standard_unit	not set for dutyCycle
	//	display_unit	not set for dutyCycle
	//	format	not set for dutyCycle
	//	max_value	not set for dutyCycle
	//	min_value	not set for dutyCycle
	//	max_alarm	not set for dutyCycle
	//	min_alarm	not set for dutyCycle
	//	max_warning	not set for dutyCycle
	//	min_warning	not set for dutyCycle
	//	delta_t	not set for dutyCycle
	//	delta_val	not set for dutyCycle
	
	dutycycle->set_default_properties(dutycycle_prop);
	//	Not Polled
	dutycycle->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dutycycle);

	//	Attribute : manufacturer
	manufacturerAttrib	*manufacturer = new manufacturerAttrib();
	Tango::UserDefaultAttrProp	manufacturer_prop;
	//	description	not set for manufacturer
	//	label	not set for manufacturer
	//	unit	not set for manufacturer
	//	standard_unit	not set for manufacturer
	//	display_unit	not set for manufacturer
	//	format	not set for manufacturer
	//	max_value	not set for manufacturer
	//	min_value	not set for manufacturer
	//	max_alarm	not set for manufacturer
	//	min_alarm	not set for manufacturer
	//	max_warning	not set for manufacturer
	//	min_warning	not set for manufacturer
	//	delta_t	not set for manufacturer
	//	delta_val	not set for manufacturer
	
	manufacturer->set_default_properties(manufacturer_prop);
	//	Not Polled
	manufacturer->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(manufacturer);

	//	Attribute : manufacturerId
	manufacturerIdAttrib	*manufacturerid = new manufacturerIdAttrib();
	Tango::UserDefaultAttrProp	manufacturerid_prop;
	//	description	not set for manufacturerId
	//	label	not set for manufacturerId
	//	unit	not set for manufacturerId
	//	standard_unit	not set for manufacturerId
	//	display_unit	not set for manufacturerId
	//	format	not set for manufacturerId
	//	max_value	not set for manufacturerId
	//	min_value	not set for manufacturerId
	//	max_alarm	not set for manufacturerId
	//	min_alarm	not set for manufacturerId
	//	max_warning	not set for manufacturerId
	//	min_warning	not set for manufacturerId
	//	delta_t	not set for manufacturerId
	//	delta_val	not set for manufacturerId
	
	manufacturerid->set_default_properties(manufacturerid_prop);
	//	Not Polled
	manufacturerid->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(manufacturerid);

	//	Attribute : ProductDescription
	ProductDescriptionAttrib	*productdescription = new ProductDescriptionAttrib();
	Tango::UserDefaultAttrProp	productdescription_prop;
	//	description	not set for ProductDescription
	//	label	not set for ProductDescription
	//	unit	not set for ProductDescription
	//	standard_unit	not set for ProductDescription
	//	display_unit	not set for ProductDescription
	//	format	not set for ProductDescription
	//	max_value	not set for ProductDescription
	//	min_value	not set for ProductDescription
	//	max_alarm	not set for ProductDescription
	//	min_alarm	not set for ProductDescription
	//	max_warning	not set for ProductDescription
	//	min_warning	not set for ProductDescription
	//	delta_t	not set for ProductDescription
	//	delta_val	not set for ProductDescription
	
	productdescription->set_default_properties(productdescription_prop);
	//	Not Polled
	productdescription->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(productdescription);

	//	Attribute : major
	majorAttrib	*major = new majorAttrib();
	Tango::UserDefaultAttrProp	major_prop;
	//	description	not set for major
	//	label	not set for major
	//	unit	not set for major
	//	standard_unit	not set for major
	//	display_unit	not set for major
	//	format	not set for major
	//	max_value	not set for major
	//	min_value	not set for major
	//	max_alarm	not set for major
	//	min_alarm	not set for major
	//	max_warning	not set for major
	//	min_warning	not set for major
	//	delta_t	not set for major
	//	delta_val	not set for major
	
	major->set_default_properties(major_prop);
	//	Not Polled
	major->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(major);

	//	Attribute : minor
	minorAttrib	*minor = new minorAttrib();
	Tango::UserDefaultAttrProp	minor_prop;
	//	description	not set for minor
	//	label	not set for minor
	//	unit	not set for minor
	//	standard_unit	not set for minor
	//	display_unit	not set for minor
	//	format	not set for minor
	//	max_value	not set for minor
	//	min_value	not set for minor
	//	max_alarm	not set for minor
	//	min_alarm	not set for minor
	//	max_warning	not set for minor
	//	min_warning	not set for minor
	//	delta_t	not set for minor
	//	delta_val	not set for minor
	
	minor->set_default_properties(minor_prop);
	//	Not Polled
	minor->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(minor);

	//	Attribute : release
	releaseAttrib	*release = new releaseAttrib();
	Tango::UserDefaultAttrProp	release_prop;
	//	description	not set for release
	//	label	not set for release
	//	unit	not set for release
	//	standard_unit	not set for release
	//	display_unit	not set for release
	//	format	not set for release
	//	max_value	not set for release
	//	min_value	not set for release
	//	max_alarm	not set for release
	//	min_alarm	not set for release
	//	max_warning	not set for release
	//	min_warning	not set for release
	//	delta_t	not set for release
	//	delta_val	not set for release
	
	release->set_default_properties(release_prop);
	//	Not Polled
	release->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(release);

	//	Attribute : serialNumber
	serialNumberAttrib	*serialnumber = new serialNumberAttrib();
	Tango::UserDefaultAttrProp	serialnumber_prop;
	//	description	not set for serialNumber
	//	label	not set for serialNumber
	//	unit	not set for serialNumber
	//	standard_unit	not set for serialNumber
	//	display_unit	not set for serialNumber
	//	format	not set for serialNumber
	//	max_value	not set for serialNumber
	//	min_value	not set for serialNumber
	//	max_alarm	not set for serialNumber
	//	min_alarm	not set for serialNumber
	//	max_warning	not set for serialNumber
	//	min_warning	not set for serialNumber
	//	delta_t	not set for serialNumber
	//	delta_val	not set for serialNumber
	
	serialnumber->set_default_properties(serialnumber_prop);
	//	Not Polled
	serialnumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(serialnumber);

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Standa8smc4usbClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Standa8smc4usbClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Standa8smc4usbClass::command_factory()
{
	/*----- PROTECTED REGION ID(Standa8smc4usbClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::command_factory_before


	//	Command Left
	LeftClass	*pLeftCmd =
		new LeftClass("Left",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pLeftCmd);

	//	Command Right
	RightClass	*pRightCmd =
		new RightClass("Right",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pRightCmd);

	//	Command Stop
	StopClass	*pStopCmd =
		new StopClass("Stop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopCmd);

	//	Command Sstop
	SstopClass	*pSstopCmd =
		new SstopClass("Sstop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSstopCmd);

	//	Command Move
	MoveClass	*pMoveCmd =
		new MoveClass("Move",
			Tango::DEV_FLOAT, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pMoveCmd);

	//	Command Mover
	MoverClass	*pMoverCmd =
		new MoverClass("Mover",
			Tango::DEV_FLOAT, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pMoverCmd);

	//	Command Home
	HomeClass	*pHomeCmd =
		new HomeClass("Home",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pHomeCmd);

	/*----- PROTECTED REGION ID(Standa8smc4usbClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Standa8smc4usbClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void Standa8smc4usbClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(Standa8smc4usbClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Standa8smc4usbClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Standa8smc4usbClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Standa8smc4usb *dev = static_cast<Standa8smc4usb *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Standa8smc4usbClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Standa8smc4usbClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Standa8smc4usbClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Standa8smc4usbClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Standa8smc4usbClass::Additional Methods
} //	namespace
